Package net.sf.saxon.expr.sort

## Class DescendingComparer

- java.lang.Object
- - net.sf.saxon.expr.sort.DescendingComparer

- All Implemented Interfaces:
    `AtomicComparer`

      public class DescendingComparer
      extends java.lang.Object
      implements AtomicComparer

  A Comparer used for comparing descending keys. This simply returns the inverse of the result delivered by the base comparer.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DescendingComparer​(AtomicComparer base)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareAtomicValues​(AtomicValue a, AtomicValue b)` | Compare two objects.
    `boolean` | `comparesEqual​(AtomicValue a, AtomicValue b)` | Compare two AtomicValue objects for equality according to the rules for their data type.
    `AtomicComparer` | `getBaseComparer()` | Get the underlying (ascending) comparer
    `StringCollator` | `getCollator()` | Get the collation used by this AtomicComparer if any
    `AtomicComparer` | `provideContext​(XPathContext context)` | Supply the dynamic context in case this is needed for the comparison
    `java.lang.String` | `save()` | Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DescendingComparer

          public DescendingComparer​(AtomicComparer base)

  - ### Method Detail

    - #### getBaseComparer

          public AtomicComparer getBaseComparer()

      Get the underlying (ascending) comparer
      Returns:
        the underlying (ascending) comparer

    - #### getCollator

          public StringCollator getCollator()

      Description copied from interface: `AtomicComparer`
      Get the collation used by this AtomicComparer if any
      Specified by:
        `getCollator` in interface `AtomicComparer`
      Returns:
        the collation used for comparing strings, or null if not applicable

    - #### provideContext

          public AtomicComparer provideContext​(XPathContext context)

      Supply the dynamic context in case this is needed for the comparison
      Specified by:
        `provideContext` in interface `AtomicComparer`
      Parameters:
        `context` - the dynamic evaluation context
      Returns:
        either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

    - #### compareAtomicValues

          public int compareAtomicValues​(AtomicValue a,
                                         AtomicValue b)
                                  throws NoDynamicContextException

      Compare two objects.
      Specified by:
        `compareAtomicValues` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        <0 if a<b, 0 if a=b, >0 if a>b
      Throws:
        `java.lang.ClassCastException` - if the objects are of the wrong type for this Comparer
        `NoDynamicContextException` - if this comparer required access to dynamic context information, notably the implicit timezone, and this information is not available. In general this happens if a context-dependent comparison is attempted at compile-time, and it signals the compiler to generate code that tries again at run-time.

    - #### comparesEqual

          public boolean comparesEqual​(AtomicValue a,
                                       AtomicValue b)
                                throws NoDynamicContextException

      Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.
      Specified by:
        `comparesEqual` in interface `AtomicComparer`
      Parameters:
        `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
        `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
      Returns:
        true if the values are equal, false if not
      Throws:
        `java.lang.ClassCastException` - if the objects are not comparable
        `NoDynamicContextException`

    - #### save

          public java.lang.String save()

      Create a string representation of this AtomicComparer that can be saved in a compiled package and used to reconstitute the AtomicComparer when the package is reloaded
      Specified by:
        `save` in interface `AtomicComparer`
      Returns:
        a string representation of the AtomicComparer